/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
	"fmt"
)

// ContactStrictAttributeValue - struct for ContactStrictAttributeValue
type ContactStrictAttributeValue struct {
	Bool *bool
	Float32 *float32
	String *string
}

// boolAsContactStrictAttributeValue is a convenience function that returns bool wrapped in ContactStrictAttributeValue
func BoolAsContactStrictAttributeValue(v *bool) ContactStrictAttributeValue {
	return ContactStrictAttributeValue{
		Bool: v,
	}
}

// float32AsContactStrictAttributeValue is a convenience function that returns float32 wrapped in ContactStrictAttributeValue
func Float32AsContactStrictAttributeValue(v *float32) ContactStrictAttributeValue {
	return ContactStrictAttributeValue{
		Float32: v,
	}
}

// stringAsContactStrictAttributeValue is a convenience function that returns string wrapped in ContactStrictAttributeValue
func StringAsContactStrictAttributeValue(v *string) ContactStrictAttributeValue {
	return ContactStrictAttributeValue{
		String: v,
	}
}


// Unmarshal JSON data into one of the pointers in the struct
func (dst *ContactStrictAttributeValue) UnmarshalJSON(data []byte) error {
	var err error
	match := 0
	// try to unmarshal data into Bool
	err = newStrictDecoder(data).Decode(&dst.Bool)
	if err == nil {
		jsonBool, _ := json.Marshal(dst.Bool)
		if string(jsonBool) == "{}" { // empty struct
			dst.Bool = nil
		} else {
			match++
		}
	} else {
		dst.Bool = nil
	}

	// try to unmarshal data into Float32
	err = newStrictDecoder(data).Decode(&dst.Float32)
	if err == nil {
		jsonFloat32, _ := json.Marshal(dst.Float32)
		if string(jsonFloat32) == "{}" { // empty struct
			dst.Float32 = nil
		} else {
			match++
		}
	} else {
		dst.Float32 = nil
	}

	// try to unmarshal data into String
	err = newStrictDecoder(data).Decode(&dst.String)
	if err == nil {
		jsonString, _ := json.Marshal(dst.String)
		if string(jsonString) == "{}" { // empty struct
			dst.String = nil
		} else {
			match++
		}
	} else {
		dst.String = nil
	}

	if match > 1 { // more than 1 match
		// reset to nil
		dst.Bool = nil
		dst.Float32 = nil
		dst.String = nil

		return fmt.Errorf("data matches more than one schema in oneOf(ContactStrictAttributeValue)")
	} else if match == 1 {
		return nil // exactly one match
	} else { // no match
		return fmt.Errorf("data failed to match schemas in oneOf(ContactStrictAttributeValue)")
	}
}

// Marshal data from the first non-nil pointers in the struct to JSON
func (src ContactStrictAttributeValue) MarshalJSON() ([]byte, error) {
	if src.Bool != nil {
		return json.Marshal(&src.Bool)
	}

	if src.Float32 != nil {
		return json.Marshal(&src.Float32)
	}

	if src.String != nil {
		return json.Marshal(&src.String)
	}

	return nil, nil // no data in oneOf schemas
}

// Get the actual instance
func (obj *ContactStrictAttributeValue) GetActualInstance() (interface{}) {
	if obj == nil {
		return nil
	}
	if obj.Bool != nil {
		return obj.Bool
	}

	if obj.Float32 != nil {
		return obj.Float32
	}

	if obj.String != nil {
		return obj.String
	}

	// all schemas are nil
	return nil
}

type NullableContactStrictAttributeValue struct {
	value *ContactStrictAttributeValue
	isSet bool
}

func (v NullableContactStrictAttributeValue) Get() *ContactStrictAttributeValue {
	return v.value
}

func (v *NullableContactStrictAttributeValue) Set(val *ContactStrictAttributeValue) {
	v.value = val
	v.isSet = true
}

func (v NullableContactStrictAttributeValue) IsSet() bool {
	return v.isSet
}

func (v *NullableContactStrictAttributeValue) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableContactStrictAttributeValue(val *ContactStrictAttributeValue) *NullableContactStrictAttributeValue {
	return &NullableContactStrictAttributeValue{value: val, isSet: true}
}

func (v NullableContactStrictAttributeValue) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableContactStrictAttributeValue) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


